unit Hook;

interface

uses
  Windows, Classes, SysUtils, TraceTool;

type
  THook = class
  private
    FRecvFunc1: DWORD;
    FRecvFunc2: DWORD;
    FRecvFromFunc1: DWORD;
    FRecvFromFunc2: DWORD;
    FHookList: TStringList;
    function CanHook(rva: DWORD; var func: string): DWORD;
    procedure setHook(funcpos, oldfunc, newfunc: DWORD);
    procedure unsetHook(funcpos, func: DWORD);
  public
    constructor Create;
    function Hook(rva: DWORD): string;
    procedure UnHook;
  end;
var
  GHook: THook;
  SendFunc: DWORD;
  SendToFunc: DWORD;
  RecvFunc: DWORD;
  RecvFromFunc: DWORD;
  retAddr: DWORD;
  buf: DWORD;

implementation

uses
  Unit1;

//  pushad
//  pushfd
//  mov eax, Form1
//  mov edx, [esp+$2C]
//  mov ecx, [esp+$30]
//  call TForm1.OnSend
//  popfd
//  popad
procedure mySend;
asm
  pushad
  pushfd
  mov eax, Form1
  mov edx, [esp+$2C]
  mov ecx, [esp+$30]
  call TForm1.OnSend
  popfd
  popad
  jmp [SendFunc]
end;

procedure mySendTo;
asm
  jmp [SendToFunc]
end;

procedure myRecv;
asm
  pop eax
  mov retAddr, eax
  mov eax, [esp+4]
  mov buf, eax
  call @@rethere
@@rethere:
  pop eax
  add eax, 11
  push eax
  jmp [RecvFunc]
  push eax
  pushad
  pushfd
  mov ecx, eax
  mov eax, Form1
  mov edx, buf
  call TForm1.OnRecv
  popfd
  popad
  pop eax
  jmp [retAddr]
end;

procedure myRecvFrom;
asm
  jmp [RecvFromFunc]
end;

{ THook }

function THook.CanHook(rva: DWORD; var func: string): DWORD;
var
  v: DWORD;
begin
  Result := 0;
  func := '';
  v := DWORD(Pointer(rva)^);
  if v = SendFunc then begin
    Result := v;
    func := 'send';
//  end else if v = SendToFunc then begin
//    Result := v;
//    func := 'sendto';
  end else if v = FRecvFunc1 then begin
    Result := v;
    func := 'recv';
    RecvFunc := FRecvFunc1;
  end else if v = FRecvFunc2 then begin
    Result := v;
    func := 'recv';
    RecvFunc := FRecvFunc2;
//  end else if v = FRecvFromFunc1 then begin
//    Result := v;
//    func := 'recvfrom';
//    RecvFunc := FRecvFromFunc1;
//  end else if v = FRecvFromFunc2 then begin
//    Result := v;
//    func := 'recvfrom';
//    RecvFunc := FRecvFromFunc2;
  end;
end;

constructor THook.Create;
var
  hlib: DWORD;
begin
  SendFunc := 0;
  SendToFunc := 0;
  RecvFunc := 0;
  FRecvFunc1 := 0;
  FRecvFunc2 := 0;
  RecvFromFunc := 0;
  FRecvFromFunc1 := 0;
  FRecvFromFunc2 := 0;
  hlib := GetModuleHandle('ws2_32.dll');
  if hlib <> 0 then begin
    SendFunc := DWORD(GetProcAddress(hlib, 'send'));
    SendToFunc := DWORD(GetProcAddress(hlib, 'sendto'));
    FRecvFunc1 := DWORD(GetProcAddress(hlib, 'recv'));
    FRecvFromFunc1 := DWORD(GetProcAddress(hlib, 'recvfrom'));
  end;
  hlib := GetModuleHandle('WSOCK32.dll');
  if hlib <> 0 then begin
    FRecvFunc2 := DWORD(GetProcAddress(hlib, 'recv'));
    FRecvFromFunc2 := DWORD(GetProcAddress(hlib, 'recvfrom'));
  end;
  FHookList := TStringList.Create;
end;

function THook.Hook(rva: DWORD): string;
var
  funcType: string;
  oldfunc, newfunc: DWORD;

begin
  Result := '';
  oldfunc := CanHook(rva, funcType);
  if oldfunc = 0 then
    Exit;
  Result := funcType;
  if funcType = 'send' then
    newfunc := DWORD(@mySend)
  else if funcType = 'sendto' then
    newfunc := DWORD(@mySendTo)
  else if funcType = 'recv' then
    newfunc := DWORD(@myRecv)
  else
    newfunc := DWORD(@myRecvFrom);
  setHook(rva, oldfunc, newfunc);
end;

procedure THook.setHook(funcpos, oldfunc, newfunc: DWORD);
var
  mem: TMemoryBasicInformation;
  p: dword;
begin
  VirtualQuery(Pointer(funcpos), mem, SizeOf(mem));
  VirtualProtect(mem.BaseAddress, mem.RegionSize, $40, p);
  Move(newfunc, Pointer(funcpos)^, 4);
  VirtualProtect(mem.BaseAddress, mem.RegionSize, p, nil);
  FHookList.AddObject(IntToStr(funcpos), TObject(oldfunc));
end;

procedure THook.UnHook;
var
  i: Integer;
begin
  for i:=0 to FHookList.Count-1 do begin
    unsetHook(StrToInt(FHookList[i]), DWORD(FHookList.Objects[i]));
  end;
end;

procedure THook.unsetHook(funcpos, func: DWORD);
var
  mem: TMemoryBasicInformation;
  p: dword;
begin
  VirtualQuery(Pointer(funcpos), mem, SizeOf(mem));
  VirtualProtect(mem.BaseAddress, mem.RegionSize, $40, p);
  Move(func, Pointer(funcpos)^, 4);
  VirtualProtect(mem.BaseAddress, mem.RegionSize, p, nil);
end;

end.

