unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TraceTool;

type
  PImageImportDescriptor = ^TImageImportDescriptor;
  TImageImportDescriptor = packed record
    OriginalFirstThunk: DWORD;
    TimeDateStamp: DWORD;
    ForwarderChain: DWORD;
    Name: DWORD;
    FirstThunk: DWORD;
  end;

  TForm1 = class(TForm)
    lbl1: TLabel;
    mmoPacket: TMemo;
    chkActive: TCheckBox;
    btnClear: TButton;
    btnSave: TButton;
    lbl2: TLabel;
    lblSend: TLabel;
    lblRecv: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
    FVA: DWORD;
    procedure HookNetwork(rva: DWORD);
    function GetNetworkHandle: DWORD;
  public
    { Public declarations }
    procedure OnSend(buf: Pointer; size: DWORD);
    procedure OnRecv(buf: Pointer; size: DWORD);    
  end;

var
  Form1: TForm1;

implementation

uses Hook;

{$R *.dfm}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  ret: DWORD;
begin
  ret := MessageBox(Self.Handle, 'Twn}ܡH', 'T', MB_YESNO);
  if ret = ID_NO then
    CanClose := False;
  GHook.UnHook;
  Sleep(2000);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  hmod: DWORD;
  nthead: PImageNtHeaders;
  v: DWORD;
begin
  GHook := THook.Create;
  hmod := GetNetworkHandle;
  if hmod = 0 then begin
    MessageBox(self.Handle, '{Sϥκ, GLk.', 'T', MB_OK or MB_ICONWARNING);
    chkActive.Checked := False;
    chkActive.Enabled := False;
    Exit;
  end;
  FVA := GetModuleHandle(nil);
  v := DWORD(Pointer(FVA + $3C)^);
  Inc(v, FVA);
  nthead := Pointer(v);
  if nthead.OptionalHeader.DataDirectory[1].VirtualAddress = 0 then begin
    MessageBox(Self.Handle, '䤣 IAT, ɥiQ[KF!', 'T', MB_OK or MB_ICONWARNING);
    chkActive.Checked := False;
    chkActive.Enabled := False;
    Exit;
  end;
  HookNetwork(nthead.OptionalHeader.DataDirectory[1].VirtualAddress);
end;

function TForm1.GetNetworkHandle: DWORD;
begin
  Result := GetModuleHandle('ws2_32.dll');
  if Result = 0 then
    Result := GetModuleHandle('WSOCK32.dll');
end;

procedure TForm1.HookNetwork(rva: DWORD);
var
  impdesc: PImageImportDescriptor;
  v: DWORD;
  s: string;
begin
  impdesc := Pointer(FVA + rva);
  s := UpperCase(StrPas(Pointer(FVA + impdesc^.Name)));
  while (s <> 'WS2_32.DLL') and (s <> 'WSOCK32.DLL') do begin
    Inc(rva, SizeOf(TImageImportDescriptor));
    impdesc := Pointer(FVA + rva);
    if impdesc^.Name = 0 then
      Break;
    s := UpperCase(StrPas(Pointer(FVA + impdesc^.Name)));
  end;
  if (s <> 'WS2_32.DLL') and (s <> 'WSOCK32.DLL') then begin
    MessageBox(Self.Handle, 'b IAT 䤣 NETWORK,'#13#10'ɥiQ[KF!', 'T', MB_OK or MB_ICONWARNING);
    Exit;
  end;
  rva := FVA + impdesc^.FirstThunk;
  v := DWORD(Pointer(rva)^);
  while v <> 0 do begin
    s := GHook.Hook(rva);
    if s = 'send' then
      lblSend.Enabled := True
    else if s = 'recv' then
      lblRecv.Enabled := True;
    Inc(rva, 4);
    v := DWORD(Pointer(rva)^);
  end;
end;

procedure TForm1.OnRecv(buf: Pointer; size: DWORD);
var
  barr: PByteArray;
  i: Integer;
  s: string;
begin
  if not chkActive.Checked then
    Exit;
  barr := buf;
  s := 'recv: ';
  for i := 0 to size - 1 do begin
    s := s + Format('%.2X ', [barr[i]]);
  end;
  mmoPacket.Lines.Add(s);
end;

procedure TForm1.OnSend(buf: Pointer; size: DWORD);
var
  barr: PByteArray;
  i: Integer;
  s: string;
begin
  if not chkActive.Checked then
    Exit;
  barr := buf;
  s := 'send: ';
  for i := 0 to size - 1 do begin
    s := s + Format('%.2X ', [barr[i]]);
  end;
  mmoPacket.Lines.Add(s);
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  mmoPacket.Clear;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
begin
  mmoPacket.Lines.SaveToFile('C:\Packets.txt');
end;

end.

